{nabor podprogramm dlq raboty s ISIS'owskimi *.mol i t.p.}

 type vect3=array[1..3] of real;

 type x_r=record obozn:string[2]; r:vect3; chg,rad:integer; end;

 type molec=record
  n_at,n_sv:integer;
  xr:array[1..300] of x_r;
  sv:array[1..350,1..3] of integer;
 end;

 function opred_brutto(var m:molec):string; forward;

 function ne_najd_razlich(var m1,m2:molec):boolean;
  var s1,s2:string;
  var mark,sosed1,sosed2:array[1..300] of byte;
  var i,j,chislo,chislo_:integer;
  function izotip(a,b:x_r; sosed_a,sosed_b:integer):boolean;
  begin
   izotip:=(a.obozn=b.obozn) and (a.chg=b.chg)
     and (a.rad=b.rad) and (sosed_a=sosed_b);
  end;
 begin
  s1:=opred_brutto(m1); s2:=opred_brutto(m2);
  if s1<>s2 then begin ne_najd_razlich:=false; exit; end;
  for i:=1 to 300 do mark[i]:=0;
  for i:=1 to m1.n_at do begin
   sosed1[i]:=0;
   for j:=1 to m1.n_sv do if (m1.sv[j,1]=i) or (m1.sv[j,2]=i) then inc(sosed1[i]);
  end;
  for i:=1 to m2.n_at do begin
   sosed2[i]:=0;
   for j:=1 to m2.n_sv do if (m2.sv[j,1]=i) or (m2.sv[j,2]=i) then inc(sosed2[i]);
  end;
  {nashli chislo sosedej u kazhdogo atoma}
  for i:=1 to m1.n_at do if mark[i]=0 then begin
   mark[i]:=i; chislo:=1;
   for j:=i+1 to m1.n_at do if izotip(m1.xr[i],m1.xr[j],sosed1[i],sosed1[j]) then begin
    mark[j]:=i; inc(chislo);
   end;
   {najdeno chislo izotipn. atomov - napr., N s zarqdom 1 i 4-mq swqzqmi}
   chislo_:=0; for j:=1 to m2.n_at do if izotip(m1.xr[i],m2.xr[j],sosed1[i],sosed2[j]) then inc(chislo_);
   if chislo_<>chislo then begin ne_najd_razlich:=false; exit; end;
  end;
  ne_najd_razlich:=true;
 end;

 procedure razbor_CHG(s:string; var m:molec);
  var b:text; n,i,itip,iat,iq,iq_total:integer; stip:string[3];
 begin
  stip:=copy(s,4,3); {'CHG' - zarqdy, 'RAD' - radik. centry}
  if stip='CHG' then itip:=1
    else if stip='RAD' then itip:=2
    else begin
   writeln('razbor_CHG: tip=/',stip,'/ - !!!'); halt;
  end;
  s:=copy(s,7,250);
  assign(b,'tempor.txt'); rewrite(b); writeln(b,s); close(b);
  reset(b); read(b,n);
  iq_total:=0; for i:=1 to n do begin
   read(b,iat,iq);
   if itip=1 then begin
    m.xr[iat].chg:=iq; iq_total:=iq_total+iq;
   end else m.xr[iat].rad:=iq;
  end;
  close(b);
  if iq_total<>0 then begin
   writeln('iq_total=',iq_total,' - !!!'); 
   for i:=1 to m.n_at do with m.xr[i] do if chg<>0 then
     writeln(i:4,' ',obozn:2,' ',chg:2);
   readln;
  end;
 end;

 procedure vv_mol(var b:text; var m:molec);
 {nahodimsq pered opisaniem struktury; w konce - posle 'M  END'}
  var s:string; i,kod:integer; s_CHG:string[6];
  var fiktivn:char {dlq `teniq probela};
 begin
  {repeat readln(b,s) until eof(b) or (pos('-ISIS-',s)>0);}
  {if eof(b) then begin writeln('eof !!!'); halt; end;}
  readln(b,s); if (s<>'') and (s<>' ') then writeln(s); {m.b.nazwanie}
  readln(b,s);
  if pos('-ISIS-',s)=0 then begin writeln('Net -ISIS- : /',s,'/'); halt; end;
  readln(b,s); if (s<>'') and (s<>' ') then writeln(s); {m.b.komment.}
  {readln(b,m.n_at,m.n_sv);}
  {bywaet >=100 atomow, pri etom dannye - po formatu 2i3}
  readln(b,s);
  val(copy(s,1,3),m.n_at,kod); if kod<>0 then begin writeln('/',s,'/ !!!'); halt; end;
  val(copy(s,4,3),m.n_sv,kod); if kod<>0 then begin writeln('/',s,'/ !!!'); halt; end;
  for i:=1 to m.n_at do begin
   readln(b,m.xr[i].r[1],m.xr[i].r[2],m.xr[i].r[3],fiktivn,m.xr[i].obozn);
   {writeln(m.xr[i].r[1]:10:4,m.xr[i].r[2]:10:4,m.xr[i].r[3]:10:4,'/',m.xr[i].obozn,'/');}
   m.xr[i].chg:=0; m.xr[i].rad:=0;
  end;
  for i:=1 to m.n_sv do begin
   {readln(b,m.sv[i,1],m.sv[i,2],m.sv[i,3]);}
   {analog. - po formatu 3i3}
   readln(b,s);
   val(copy(s,1,3),m.sv[i,1],kod); if kod<>0 then begin writeln('!!!'); halt; end;
   val(copy(s,4,3),m.sv[i,2],kod); if kod<>0 then begin writeln('!!!'); halt; end;
   val(copy(s,7,3),m.sv[i,3],kod); if kod<>0 then begin writeln('!!!'); halt; end;
  end;
  repeat
   readln(b,s); s_CHG:=copy(s,1,6);
   if (s_CHG='M  CHG') or (s_CHG='M  RAD') then razbor_CHG(s,m);
  until eof(b) or (s_CHG='M  END');
 end;

 procedure vv_mol_file(imq:string; var m:molec); var b:text;
 begin
 writeln(imq); readln;

 assign(b,imq); reset(b); vv_mol(b,m); close(b); end;

 procedure do_konca_opis(var b:text); var s:string;
 {prodwig. do konca opis. molekuly w ISIS-baze}
 begin
  if not eof(b) then repeat
   readln(b,s);
  until eof(b) or (pos('$$$$',s)=1);
 end;

 procedure centrir_mol(var m:molec); {wychit. koord. centra molekuly}
  var rc:vect3; i,j:integer;
 begin
  for j:=1 to 3 do rc[j]:=0;
  for i:=1 to m.n_at do for j:=1 to 3 do rc[j]:=rc[j]+m.xr[i].r[j];
  for j:=1 to 3 do rc[j]:=rc[j]/m.n_at;
  for i:=1 to m.n_at do for j:=1 to 3 do m.xr[i].r[j]:=m.xr[i].r[j]-rc[j];
 end;

 function predp_H(var m:molec):integer;
  var i,j,svq,q,r,nH:integer; obo:string[2]; gut:boolean;
  var nH_qwn:integer;
 begin with m do begin
  nH:=0; nH_qwn:=0;
  for i:=1 to n_at do begin
   obo:=xr[i].obozn;
   svq:=0;
   for j:=1 to n_sv do if (sv[j,1]=i) or (sv[j,2]=i) then svq:=svq+sv[j,3];
   q:=xr[i].chg;
   if xr[i].rad=0 then r:=0
     else if xr[i].rad=1 then r:=2
     else if xr[i].rad=2 then r:=1
     else begin writeln('xr[i].rad=',xr[i].rad,' - !!!'); end;
   {svq - chislo najdennyh swqzej; q - prostawlennyj zarqd; r - chislo
     torchashchih walentnostej.
   }
   {writeln(i:4,obo:4,' ',svq:4,' ',q:4,' ',r:4);}
   if (obo='C ') or (obo='Si') then begin
    svq:=svq+abs(q)+abs(r); nH:=nH+(4-svq);
    {Smysl: dlq C i '+', i '-', i '.' \kwiw. swqzi -
      i R3C+, i R3C-, i R3C, i R2C: ne trebu$t atomow H.
    }
   end else if (obo='H ') then begin
    nH:=nH+1; nH_qwn:=nH_qwn+1;
   end else if (obo='N ') or (obo='P ') then begin
    if svq<3 then nH:=nH+(3-svq);
   end else if (obo='O ') or (obo='S ') then begin
    if q=0 then if svq<2 then nH:=nH+(2-svq);
    if (q=-1) and (svq=1)  then; {RO-}
   end else if (obo='F ') or (obo='Cl') or (obo='Br') or (obo='I ') then begin
    if svq<1 then nH:=nH+(1-svq);
   end else if obo='Na' then begin
    gut:=((svq=0) and (q=1)) or ((svq=1) and (q=0));
    if not gut then begin write('Podozritelxn. atom Na: ',svq,' ',q); readln; end;
   end else if obo='B ' then begin
    gut:=((svq=3) and (q=0)) or ((svq=4) and (q=-1));
    if not gut then begin write('Podozritelxn. atom B: ',svq,' ',q); readln; end;
   end else if obo='* ' then begin
    {ni`ego ne delaem}
   end else begin
    writeln('Neizw. element: /',obo,'/');
   end;
   {writeln(i:5,n_at:5,obo:5,nH_qwn:5,nH:5);}
  end {i:=1 to n_at};
  if nH<>nH_qwn then begin
   writeln('nH_qwn,nH=',nH_qwn,' ',nH,' - !!!'); readln;
  end;
  predp_H:=nH;
 end end;

 const n_known_elt=14;
 const o_elt:array[1..n_known_elt] of string[2]=(
   'C ','H ','N ','O ','S ',
   'F ','Cl','Br','I ','Na',
   'B ','Si','P ','* '
 );
 const m_elt:array[1..n_known_elt] of real=(
   12.0107, 1.00794, 14.00674, 15.9994,  32.0666,
   18.9984, 35.4527, 79.904,  126.90447, 22.989770,
   10.811,  28.0855, 30.973762, 0.0
 );

 var mol_mass:real;

 function opred_brutto(var m:molec):string;
  var s:string; sn:string[6];
  var i,j,nx,nH:integer;
  var n:array[1..n_known_elt] of integer;
  var known:boolean;
 begin with m do begin
  s:=''; mol_mass:=0;
  for j:=1 to n_known_elt do n[j]:=0; nx:=0;
  for i:=1 to n_at do begin
   known:=false;
   for j:=1 to n_known_elt do begin
    if xr[i].obozn=o_elt[j] then begin
     inc(n[j]); mol_mass:=mol_mass+m_elt[j]; known:=true; 
    end;
   end;
   if not known then begin inc(nx); writeln('not known: ',xr[i].obozn); end;
  end;
  nH:=predp_H(m);
  mol_mass:=mol_mass+m_elt[2]*nH;
  for j:=1 to n_known_elt do if n[j]>0 then begin
   str(n[j],sn); s:=s+o_elt[j]+' '+sn+' ';
  end;
  srez_hwost(s); ubr_powt_prob(s);
  opred_brutto:=s;
 end; end;

 procedure write_brutto(var m:molec); var s:string;
 begin s:=opred_brutto(m); write(s); end;

 function opred_chg(var m:molec):string;
  var s,ss:string; i:integer;
 begin with m do begin
  s:='';
  for i:=1 to n_at do if (xr[i].chg<>0) or (xr[i].rad<>0) then begin
   str(i,ss); s:=s+' '+ss;
   if xr[i].chg<>0 then begin str(xr[i].chg,ss); s:=s+' '+ss; end;
   if xr[i].rad<>0 then begin str(xr[i].rad,ss); s:=s+' r'+ss; end;
  end;
  opred_chg:=s;
 end end;

 procedure write_chg(var m:molec); var s:string;
 begin s:=opred_chg(m); write(s); end;

 var e_show_mol:ekr;
 procedure show_mol_begin;
 begin
  initgraph_12;
  prisv_ekr(e_show_mol, 0,1,0,1, -10,10,-10,10,0,1,0,1);
  prisv_ramk(e_show_mol,2,2,10,10); ramka(e_show_mol);
 end;
 procedure show_mol_end;
 begin       
  closegraph;
 end;
 procedure show_mol_(s:string; var m:molec);
  var i,j,k,color:integer; {e1:ekr;} rr,xx,yy:real; iony:boolean;
  const d=0.05; {dlq risow. kratn. swqzej}
 begin with m do begin
  writeln(s);
  write_brutto(m); writeln;
  write_chg(m); writeln;
  for i:=1 to n_at do begin
   if (xr[i].obozn='N ') then begin
    color:=9; rr:=0.2;
   end else if (xr[i].obozn='O ') then begin
    color:=12; rr:=0.2;
   end else if (xr[i].obozn='S ') then begin
    color:=14; rr:=0.2;
   end else if (xr[i].obozn='Cl') then begin
    color:=10; rr:=0.2;
   end else if (xr[i].obozn<>'C ') and (xr[i].obozn<>'H ') then begin 
    color:=13; rr:=0.2; 
   end else begin color:=7; rr:=0.05; end;
   for j:=1 to 50 do begin
    xx:=xr[i].r[1]+rr*cos(2*pi*j/50);
    yy:=xr[i].r[2]+rr*sin(2*pi*j/50);
    po(xx,yy,e_show_mol,color);
   end {j - risow. kruvka};
  end {i - perebor atomow};
  for i:=1 to n_sv do begin
   j:=sv[i,1]; k:=sv[i,2];
   l(xr[j].r[1],xr[j].r[2],xr[k].r[1],xr[k].r[2],e_show_mol,15);
   if sv[i,3]>1 then begin
    l(xr[j].r[1]+d,xr[j].r[2],xr[k].r[1]+d,xr[k].r[2],e_show_mol,15);
    l(xr[j].r[1]-d,xr[j].r[2],xr[k].r[1]-d,xr[k].r[2],e_show_mol,15);
    l(xr[j].r[1],xr[j].r[2]+d,xr[k].r[1],xr[k].r[2]+d,e_show_mol,15);
    l(xr[j].r[1],xr[j].r[2]-d,xr[k].r[1],xr[k].r[2]-d,e_show_mol,15);
   end;
  end;
  {readln;}
 end; end;
 procedure show_mol(s:string; var m:molec);
 begin
  show_mol_begin; 
  show_mol_(s,m);
  readln; show_mol_end;
 end;

