 {Nedostatok: treb. obr. wna`ale k opr_n_ciklow, zatem k opr_cikly;
  2-e obr. movno po o[ibke propustitx;
  kak ulu`[itx - neqsno.
 }
 
 {-----}

 type graf=object
  a:array[1..100,1..4] of integer; na:integer;
  {a[i,1..4] - s kakimi atomami swqzan atom Nr i}
  procedure initio;
  procedure show;
  procedure add(at1,at2:integer);
 end;

 procedure graf.initio; var i,j:integer;
 begin na:=0; for i:=1 to 100 do for j:=1 to 4 do a[i,j]:=0; end;

 procedure graf.show; var i,j:integer;
 begin
  writeln('-----');
  for i:=1 to na do begin
   write(i:3,' - '); for j:=1 to 4 do if a[i,j]>0 then write(a[i,j]:2,' ');
   writeln;
  end;
  writeln('-----');
 end;

 procedure graf.add(at1,at2:integer); var i:integer;
 begin
  i:=0; repeat inc(i) until (a[at1,i]=0) or (i>4);
  if i<=4 then a[at1,i]:=at2 else writeln('graf.add: ',at1,' ',at2,' - !!!');
  i:=0; repeat inc(i) until (a[at2,i]=0) or (i>4);
  if i<=4 then a[at2,i]:=at1 else writeln('graf.add: ',at1,' ',at2,' - !!!');
 end;

 {-----}

 type zapisx=record glub,parent,val:integer; child:array[1..4] of integer; end;

 type derewo=object
  z:array[1..200] of zapisx; nz:integer;
  n_ciklow:integer;
  uzly_ciklow,razmery_ciklow,tela_i1,tela_i2:array[1..10] of integer; 
  tela_ciklow:array[1..10,-10..10] of integer; 
  mol:graf;
  procedure initio;
  procedure show;
  function ari(at:integer):boolean;
  function is_parent(par,chi:integer):boolean;
  procedure vnes(g,p,v,c1,c2,c3,c4:integer);
  procedure obrab(glub,pare,i0:integer);
  procedure opr_n_ciklow(i0:integer);
  procedure opr_cikly;
  procedure show_cikly;
  function ari_common:boolean;
 end;

 procedure derewo.initio;
 begin nz:=0; n_ciklow:=0; mol.initio; end;

 procedure derewo.show; var iz,i:integer;
 begin
  for iz:=1 to nz do with z[iz] do begin
   for i:=1 to glub do write('  ');
   write(glub:3,' / ',parent:3,' / ',val,' / ');
   for i:=1 to 4 do if child[i]<>0 then write(child[i]:3,' ');
   writeln;
  end;
  writeln;
 end;

 procedure derewo.show_cikly;
  var i,j:integer;
 begin
  writeln('show_cikly:');
  for i:=1 to n_ciklow do begin
   write(razmery_ciklow[i]:3,' / ');
   for j:=tela_i1[i] to tela_i2[i] do write(tela_ciklow[i,j]:4);
   writeln;
  end;
  writeln;
 end;

 function derewo.is_parent(par,chi:integer):boolean;
  var iz,j:integer; b:boolean;
 begin
  b:=false;
  for iz:=1 to nz do if z[iz].val=par then begin
   for j:=1 to 4 do if abs(z[iz].child[j])=chi then b:=true;
  end;
  {writeln('  is_parent',par:4,chi:4,' ',b);}
  is_parent:=b;
 end;
 
 function derewo.ari(at:integer):boolean; var iz,j:integer; b:boolean;
 begin
  b:=false;
  for iz:=1 to nz do for j:=1 to 4 do if z[iz].child[j]=at then b:=true;
  {writeln('ari: at,b=',at,' ',b);}
  ari:=b;
 end;

 procedure derewo.vnes(g,p,v,c1,c2,c3,c4:integer);
  var c:array[1..4] of integer; i,n:integer; ari_:boolean;
 begin
  inc(nz);
  with z[nz] do begin
   glub:=g;
   parent:=p; val:=v;
   c[1]:=c1; c[2]:=c2; c[3]:=c3; c[4]:=c4;
   for i:=1 to 4 do child[i]:=0;
   n:=0; for i:=1 to 4 do if (c[i]<>0) and not is_parent(c[i],v) then begin
    ari_:=ari(c[i]);
    if ari_ then begin
     inc(n); child[n]:=-c[i];
     {writeln('cikl: ',c[i]);} inc(n_ciklow); uzly_ciklow[n_ciklow]:=c[i];
    end else begin
     inc(n); child[n]:=c[i];
    end;
   end;
  end;
 end;

 procedure derewo.obrab(glub,pare,i0:integer);
 begin
  if i0>0 then vnes(glub,pare,i0,mol.a[i0,1],mol.a[i0,2],mol.a[i0,3],mol.a[i0,4]);
 end;

 procedure derewo.opr_n_ciklow(i0:integer);
  var nz0,glub_,i,j:integer;
 begin
  if (i0<1) or (i0>mol.na) then i0:=1; {Nr atoma, s k-rogo na`in. analiz}
  obrab(0,0,i0); 
  {show;}
  glub_:=0; repeat inc(glub_);
   nz0:=nz;
   for i:=1 to nz0 do if z[i].glub=glub_-1 then begin
    for j:=1 to 4 do obrab(glub_,z[i].val,z[i].child[j]);
   end;
   {show;}
  until nz=nz0;
  {writeln('n_ciklow=',n_ciklow);}
 end;

 procedure derewo.opr_cikly;
  var iz,ic,j,c,d1,d2:integer;
  function find_dai1_wetwx(c0:integer):integer; var iz,j,c,i:integer;
  begin
   i:=0; for iz:=1 to nz do for j:=1 to 4 do begin
    c:=z[iz].child[j]; if c=c0 then i:=iz;
   end;
   find_dai1_wetwx:=i;
  end;
  procedure wwerh(z1e,z2e:integer);
   var z1,z2,v1,v2,i1,i2:integer; b0,b1,b2:boolean;
  begin
   z1:=z1e; z2:=z2e;
   v1:=z[z1].val; v2:=z[z2].val;
   tela_ciklow[ic,0]:=abs(c); 
   tela_ciklow[ic,-1]:=v1; tela_ciklow[ic,1]:=v2; 
   i1:=-1; i2:=1;
   repeat
    z1:=find_dai1_wetwx(v1);
    if z1<>0 then begin dec(i1); v1:=z[z1].val; tela_ciklow[ic,i1]:=v1; end;
    z2:=find_dai1_wetwx(v2);
    if z2<>0 then begin inc(i2); v2:=z[z2].val; tela_ciklow[ic,i2]:=v2; end;
    b0:=v1=v2;
    b1:=v1=tela_ciklow[ic,i2-1];
    b2:=v2=tela_ciklow[ic,i1+1]; 
   until b0 or b1 or b2;
   if b2 then inc(i1); if b1 then dec(i2);
   tela_i1[ic]:=i1; tela_i2[ic]:=i2; razmery_ciklow[ic]:=i2-i1;
  end;
 begin
  ic:=0; for iz:=1 to nz do for j:=1 to 4 do begin
   c:=z[iz].child[j]; if c<0 then begin
    {c - nomer atoma, na k-ryj do togo uzhe wyshli inym put@m}
    inc(ic);
    {writeln('opr_cikly: ic,c=',ic:5,c:5);}
    d1:=find_dai1_wetwx(abs(c)); d2:=iz;
    wwerh(d1,d2);
   end; 
  end;
 end;

 function derewo.ari_common:boolean; var b_all,bij:boolean; i,j,ii,jj,ai,aj:integer;
 begin
  b_all:=false;
  for i:=1 to n_ciklow-1 do for j:=i+1 to n_ciklow do begin
   bij:=false;
   for ii:=tela_i1[i] to tela_i2[i] do begin ai:=tela_ciklow[i,ii];
    for jj:=tela_i1[j] to tela_i2[j] do begin aj:=tela_ciklow[j,jj];
     if ai=aj then bij:=true; 
    end {jj};
   end {ii};
   if bij then b_all:=true; 
  end {i,j};
  ari_common:=b_all;;
 end;

 {-----}
